# Update the order of existing release policies

POST https://app.launchdarkly.com/api/v2/projects/{projectKey}/release-policies/order
Content-Type: application/json

Update the order of existing release policies for the specified project.

Reference: https://launchdarkly.com/docs/api/release-policies-beta/post-release-policies-order

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/projects/{projectKey}/release-policies/order:
    post:
      operationId: post-release-policies-order
      summary: Update the order of existing release policies
      description: Update the order of existing release policies for the specified project.
      tags:
        - subpackage_releasePoliciesBeta
      parameters:
        - name: projectKey
          in: path
          description: The project key
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
        - name: LD-API-Version
          in: header
          description: Version of the endpoint.
          required: true
          schema:
            $ref: >-
              #/components/schemas/ApiV2ProjectsProjectKeyReleasePoliciesOrderPostParametersLdApiVersion
      responses:
        '200':
          description: Release policies updated successfully
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ReleasePolicy'
        '400':
          description: Bad request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '401':
          description: Invalid access token
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '404':
          description: Not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Error'
      requestBody:
        description: >-
          Array of release policy keys in the desired rank order (scoped
          policies only). These keys must include _all_ of the scoped release
          policies for the project.
        content:
          application/json:
            schema:
              type: array
              items:
                type: string
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    ApiV2ProjectsProjectKeyReleasePoliciesOrderPostParametersLdApiVersion:
      type: string
      enum:
        - beta
      title: ApiV2ProjectsProjectKeyReleasePoliciesOrderPostParametersLdApiVersion
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    ReleasePoliciesAccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: ReleasePoliciesAccessDeniedReasonEffect
    ReleasePoliciesAccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/ReleasePoliciesAccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: ReleasePoliciesAccessDeniedReason
    ReleasePoliciesAccessDenied:
      type: object
      properties:
        action:
          type: string
        reason:
          $ref: '#/components/schemas/ReleasePoliciesAccessDeniedReason'
      required:
        - action
        - reason
      title: ReleasePoliciesAccessDenied
    ReleasePoliciesAccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: ReleasePoliciesAccessAllowedReasonEffect
    ReleasePoliciesAccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/ReleasePoliciesAccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: ReleasePoliciesAccessAllowedReason
    ReleasePoliciesAccessAllowedRep:
      type: object
      properties:
        action:
          type: string
        reason:
          $ref: '#/components/schemas/ReleasePoliciesAccessAllowedReason'
      required:
        - action
        - reason
      title: ReleasePoliciesAccessAllowedRep
    ReleasePoliciesAccessRep:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/ReleasePoliciesAccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/ReleasePoliciesAccessAllowedRep'
      required:
        - denied
        - allowed
      title: ReleasePoliciesAccessRep
    ReleasePolicyScope:
      type: object
      properties:
        environmentKeys:
          type: array
          items:
            type: string
          description: List of environment keys this policy applies to
        flagTagKeys:
          type: array
          items:
            type: string
          description: List of flag tag keys this policy applies to
      title: ReleasePolicyScope
    ReleaseMethod:
      type: string
      enum:
        - guarded-release
        - progressive-release
      description: The release method for this policy
      title: ReleaseMethod
    ReleasePolicyStage:
      type: object
      properties:
        allocation:
          type: integer
        durationMillis:
          type: integer
          format: int64
      required:
        - allocation
        - durationMillis
      title: ReleasePolicyStage
    GuardedReleaseConfig:
      type: object
      properties:
        rolloutContextKindKey:
          type: string
          description: Context kind key to use as the randomization unit for the rollout
        minSampleSize:
          type: integer
          description: The minimum number of samples required to make a decision
        rollbackOnRegression:
          type: boolean
          description: Whether to roll back on regression
        metricKeys:
          type: array
          items:
            type: string
          description: List of metric keys
        metricGroupKeys:
          type: array
          items:
            type: string
          description: List of metric group keys
        stages:
          type: array
          items:
            $ref: '#/components/schemas/ReleasePolicyStage'
          description: List of stages
      description: Configuration for guarded releases
      title: GuardedReleaseConfig
    ProgressiveReleaseConfig:
      type: object
      properties:
        rolloutContextKindKey:
          type: string
          description: Context kind key to use as the randomization unit for the rollout
        stages:
          type: array
          items:
            $ref: '#/components/schemas/ReleasePolicyStage'
          description: List of stages
      description: Configuration for progressive releases
      title: ProgressiveReleaseConfig
    ReleasePolicy:
      type: object
      properties:
        _access:
          $ref: '#/components/schemas/ReleasePoliciesAccessRep'
        _id:
          type: string
          description: The unique identifier of the release policy
        scope:
          $ref: '#/components/schemas/ReleasePolicyScope'
        rank:
          type: integer
          description: The rank/priority of the release policy
        releaseMethod:
          $ref: '#/components/schemas/ReleaseMethod'
        guardedReleaseConfig:
          $ref: '#/components/schemas/GuardedReleaseConfig'
        progressiveReleaseConfig:
          $ref: '#/components/schemas/ProgressiveReleaseConfig'
        name:
          type: string
          description: The name of the release policy
        key:
          type: string
          description: The human-readable key of the release policy
      required:
        - _id
        - rank
        - releaseMethod
        - name
        - key
      title: ReleasePolicy
    Error:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
      required:
        - message
        - code
      title: Error
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/projects/default/release-policies/order"

payload = ["string"]
headers = {
    "LD-API-Version": "beta",
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/projects/default/release-policies/order';
const options = {
  method: 'POST',
  headers: {
    'LD-API-Version': 'beta',
    Authorization: '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '["string"]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/projects/default/release-policies/order"

	payload := strings.NewReader("[\n  \"string\"\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("LD-API-Version", "beta")
	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/projects/default/release-policies/order")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["LD-API-Version"] = 'beta'
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  \"string\"\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.launchdarkly.com/api/v2/projects/default/release-policies/order")
  .header("LD-API-Version", "beta")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  \"string\"\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.launchdarkly.com/api/v2/projects/default/release-policies/order', [
  'body' => '[
  "string"
]',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
    'LD-API-Version' => 'beta',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/projects/default/release-policies/order");
var request = new RestRequest(Method.POST);
request.AddHeader("LD-API-Version", "beta");
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  \"string\"\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "LD-API-Version": "beta",
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["string"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/projects/default/release-policies/order")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```